# Copyright (c) 2009 Outpost Embedded, LLC
# This file is part of the rebar software package.
#
# rebar is free software; you can redistribute it and/or modify it under the
# terms of the GNU General Public License version 2 as published by the Free
# Software Foundation.
#
# A copy of the license has been included in the COPYING file.

def wraps(wrapped):
    '''\
    A replacement implementation for functools.wraps, which was introduced
    in Python 2.5.
    '''
    def decorator(fn):
        try:
            fn.__name__ = wrapped.__name__
        except TypeError:
            pass
        try:
            fn.__doc__ = wrapped.__doc__
        except TypeError:
            pass
        try:
            fn.__module__ = wrapped.__module__
        except TypeError:
            pass
        return fn
    return decorator


class closing(object):
    obj = None

    def __init__(self, obj):
        self.obj = obj

    def __enter__(self):
        return self.obj

    def __exit__(self, exc_type, exc_value, exc_tb):
        self.obj.close()
