#!/usr/bin/env python

# Author: Forest Bond <forest.bond@outpostembedded.com>
# This file is in the public domain.

import os, sys, commands


sys.path.insert(0, os.path.join(os.path.dirname(__file__), 'modules'))
sys.path.insert(0, os.path.join(os.path.dirname(__file__)))


from setuplib import setup


DATADIR = os.path.join('modules', 'rebar', 'data')


def get_version(release_file):
    try:
        f = open(release_file, 'r')
        try:
            return f.read().strip()
        finally:
            f.close()
    except (IOError, OSError):
        status, output = commands.getstatusoutput('bzr revno')
        if status == 0:
            return 'bzr%s' % output.strip()
    return 'unknown'


setup(
  name = 'rebar',
  distinfo_module = 'rebar.distinfo',
  package_dir = {'rebar': os.path.join('modules', 'rebar')},
  packages = ['rebar', 'rebar.virtualizer'],
  scripts = ['rebar', 'gzimg_build', 'gzimg_write'],
  data_files_indep_pkg = [
    ('imaging', [
      os.path.join(DATADIR, 'imaging', 'disk_imaging.hook'),
      os.path.join(DATADIR, 'imaging', 'imaging_functions'),
      os.path.join(DATADIR, 'imaging', 'network_imaging.script'),
      os.path.join(DATADIR, 'imaging', 'disk_imaging.script'),
      os.path.join(DATADIR, 'imaging', 'network_imaging.hook'),
    ]),
  ],
  manpage_sources = ['rebar.xml'],
  version = get_version('release'),
)
